; feNyx AutoUpdate script

!define version "2.0 Build 83 [20b53]"
!define build "83"

;--------------------------------

SetCompressor lzma
MiscButtonText "< Zpt" "Dle >" "Storno" "Zavt"
SpaceTexts "Potebn msto: " "Voln msto: " 
InstallButtonText "Opravit" 
BrandingText " "
Caption "Automatick oprava pro program fNyx"
SubCaption 0 " "
SubCaption 1 " "
SubCaption 2 " "
SubCaption 3 " "
SubCaption 4 " "
Icon fenyx_autoupdate.ico
XPStyle on

!define WM_CLOSE 0x10
!define WM_DESTROY 0x2

;Var "login_closed"
Var "closed"

; The name of the installer
Name "fNyx AutoUpdate Executable"

; The file to write
OutFile "fenyx_autoupdate.exe"

; The default installation directory
InstallDir $PROGRAMFILES\feNyx

; detect winamp path from uninstall string if available
InstallDirRegKey HKLM \
                 "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{37310020-E8CC-4BD0-A71F-91EF73AE1663}_is1" \
                 "Inno Setup: App Path"

; The text to prompt the user to enter a directory
;DirText "Prosm vyberte cestu, kde se nachz fNyx, jinak nebude mon nainstalovat opravu:" "Prosm vyberte cestu k fNyxovi:" "Prochzet.."
;DirShow hide
# currently doesn't work - DirShow hide

; automatically close the installer when done.
AutoCloseWindow true

; hide the "show details" box
ShowInstDetails nevershow

;--------------------------------

;Pages

Page instfiles

;PageEx instfiles
;    Caption "Automatick oprava pro program fNyx"
;PageExEnd


;--------------------------------

; The stuff to install

Function .onInit
  ReadRegStr $INSTDIR HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{37310020-E8CC-4BD0-A71F-91EF73AE1663}}_is1" "Inno Setup: App Path"
  IfErrors 0 GOOD
  ReadRegStr $INSTDIR HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{37310020-E8CC-4BD0-A71F-91EF73AE1663}_is1" "Inno Setup: App Path"
  IfErrors 0 GOOD
  MessageBox MB_OK|MB_ICONSTOP "Automatick oprava pro program fNyx byla stornovna, protoe fNyx nen nainstalovn."
  Abort

  GOOD:
FunctionEnd


Section ""

  DetailPrint "Provdm opravu..." 
  SetDetailsPrint none

;  Push "nyxlogin"
;  Call CloseProgram
;  Pop $login_closed

  Push "feNyx"
  Call CloseProgram
  Pop $closed

  SetOutPath $INSTDIR

  Push "${build}"						;Rebuild
  Push "0"									;Revision
  Push "0"									;Minor
  Push "2"									;Mayor
  Push "$INSTDIR\fenyx.exe"   ;DLLFullPath
  Call FCheckVersion
  Pop $R0
  IntCmp $R0 0 +3 0 +3
  MessageBox MB_YESNO|MB_ICONSTOP|MB_TOPMOST|MB_DEFBUTTON2 "Chyba!!! $\nNa vaem disku se nachz novj soubory, ne ty co jsou v tto aktualizaci. $\nChcete pesto pokraovat?" IDYES +2
  Quit


  ; File to extract
  File "files\fenyx.exe"
  File "files\nyxlogin.exe"

  SetOutPath $SYSDIR
  File "system\odlist.ocx"
;  File "system\ccrptmr6.dll"
  RegDLL "$SYSDIR\odlist.ocx"
;  RegDLL "$SYSDIR\ccrptmr6.dll"

  SetOutPath $TEMP
  File "system\msxml4sys32.msi"
  ExecWait '"$SYSDIR\msiexec.exe" /i "$TEMP\msxml4sys32.msi" /qn'
	Delete "$TEMP\msxml4sys32.msi"

  WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{37310020-E8CC-4BD0-A71F-91EF73AE1663}_is1" "DisplayName" "fNyx ${version}"
  WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{37310020-E8CC-4BD0-A71F-91EF73AE1663}_is1" "DisplayVersion" "${version}"

  StrCmp $closed "true" +2 0
    MessageBox MB_OK|MB_ICONINFORMATION "Oprava byla spn aplikovna."

  StrCmp $closed "true" 0 +2
    Exec $INSTDIR\fenyx.exe  

  SetDetailsPrint both
SectionEnd

;--------------------------------

;Function .onVerifyInstDir
;  ;Check for feNyx installation
;  IfFileExists $INSTDIR\fenyx.exe Good
;    Abort
;  Good:
;FunctionEnd

Function CloseProgram 
  Exch $1
  Push $0
  Push $2
  loop1:
    FindWindow $0 "ThunderRT5Main" $1
    IntCmp $0 0 done1
      #SendMessage $0 ${WM_DESTROY} 0 0
      SendMessage $0 ${WM_CLOSE} 0 0
      StrCpy $2 "true"
    Sleep 100 
    Goto loop1
  done1:
  loop2:
    FindWindow $0 "ThunderRT6Main" $1
    IntCmp $0 0 done2
      #SendMessage $0 ${WM_DESTROY} 0 0
      SendMessage $0 ${WM_CLOSE} 0 0
      StrCpy $2 "true"
    Sleep 100 
    Goto loop2
  done2:
  Sleep 200
  Pop $0 
  Pop $1
  Exch $2
FunctionEnd

Function FCheckVersion
   Pop $1 ;DLLFullPath
   Pop $2 ;Mayor
   Pop $3 ;Minor
   Pop $4 ;Revision
   Pop $5 ;Rebuild


   GetDllVersion "$1" $R0 $R1
   IntOp $R2 $R0 / 0x00010000
   IntOp $R3 $R0 & 0x0000FFFF
   IntOp $R4 $R1 / 0x00010000
   IntOp $R5 $R1 & 0x0000FFFF

   StrCpy $0 "0"

   IntCmp $2 $R2 +1 lbl_less lbl_more
   IntCmp $3 $R3 +1 lbl_less lbl_more
   IntCmp $4 $R4 +1 lbl_less lbl_more
   IntCmp $5 $R5 +1 lbl_less lbl_more
   
   Goto lbl_exit

   lbl_less:    IntOp $0 $0 - 1
   Goto lbl_exit
   
   lbl_more:    IntOp $0 $0 + 1
      
   lbl_exit:       Push $0

   ClearErrors
FunctionEnd

