VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsListFriends"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IDrawListItem

Private Sub IDrawListItem_DrawItem(ByVal Item As ODLists.ListItem, ByVal Selected As Boolean, ByVal Focused As Boolean, ByVal Canvas As ODLists.Canvas)

    Dim lClr As Long
    Dim lH As Long
    Dim i As Long

    With Canvas
               
        If Selected Then
            .BackColor = vbButtonFace
            '.ForeColor = vbButtonText
            .Font.bold = True
        End If
                       
        If .Height >= 25 Then
            For i = 1 To frmMain.imlList.ListImages.Count
                If frmMain.imlList.ListImages.Item(i).key = Left(Item.text, InStr(Item.text, Chr(18)) - 1) Then
                    .PaintPicture frmMain.imlList.ListImages.Item(i).Picture, 0, 0, 40 * .Height / 50, .Height
                End If
            Next i
                                
            .CurrentX = 40 * .Height / 50 + 4
            .CurrentY = (.Height - 2 * .TextHeight(Item.text)) / 4
            .WriteLine Left(Item.text, InStr(Item.text, Chr(18)) - 1)
            .CurrentX = 40 * .Height / 50 + 4
            .CurrentY = 3 * ((.Height - 2 * .TextHeight(Item.text)) / 4) + .TextHeight(Item.text)
            .ForeColor = vbGrayText
            .WriteLine Mid(Item.text, InStr(Item.text, Chr(18)) + 1)
        Else
            .CurrentX = 2
            .CurrentY = (.Height - .TextHeight(Item.text)) / 2
            .WriteLine Left(Item.text, InStr(Item.text, Chr(18)) - 1)
        End If
        .Font.bold = False
    End With
End Sub

Private Sub IDrawListItem_MeasureItem(ByVal Item As ODLists.ListItem, Height As Long, ByVal Canvas As ODLists.Canvas)
    If Val(frmMain.nyx.GetSetting("look/showuserimage")) = 1 Then
        Height = ((Val(frmMain.nyx.GetSetting("look/iconsize")) Mod 2) + 1) * 25
    Else
        Height = Canvas.TextHeight("ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_") + 4
    End If
End Sub
