VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ColorItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IDrawListItem

Private Sub Draw3DRect_1(ByVal PB As PictureBox, ByVal X As Long, ByVal Y As Long, ByVal W As Long, ByVal H As Long)

   PB.Line (X, Y)-Step(W, 0), vb3DHighlight
   PB.Line -Step(0, H), vb3DShadow
   PB.Line -Step(-W, 0), vb3DShadow
   PB.Line -(X, Y), vb3DHighlight

End Sub

Private Sub Draw3DRect_2(ByVal PB As PictureBox, ByVal X As Long, ByVal Y As Long, ByVal W As Long, ByVal H As Long)

   PB.Line (X, Y)-Step(W, 0), vb3DShadow
   PB.Line -Step(0, H), vb3DHighlight
   PB.Line -Step(-W, 0), vb3DHighlight
   PB.Line -(X, Y), vb3DShadow

End Sub

Private Sub IDrawListItem_DrawItem( _
   ByVal Item As ListItem, _
   ByVal Selected As Boolean, _
   ByVal Focused As Boolean, _
   ByVal Canvas As Canvas)
Dim lClr As Long
Dim lH As Long

   With Canvas
      
      lH = .Height
      
      If Selected Then
         .BackColor = vbButtonFace
         .ForeColor = vbButtonText
         .Font.Bold = True
      End If
                 
      lClr = Val("&H" & Mid$(Item.Text, InStr(Item.Text, ",") + 1) & "&")
      
      .ForeColor = lClr
      .FillRect 3, 3, lH - 4, lH - 4
      .ForeColor = Item.ForeColor
      
      .CurrentX = .Height
      .CurrentY = (lH - .TextHeight(Item.Text)) / 2
      
      .WriteLine Left$(Item.Text, InStr(Item.Text, ",") - 1)
      
      .Font.Bold = False
      
   End With
   
End Sub

Private Sub IDrawListItem_MeasureItem( _
   ByVal Item As ListItem, _
   ByRef Height As Long, _
   ByVal Canvas As Canvas)

   Height = Canvas.TextHeight(Item.Text)
   Height = Height + 4
   
End Sub


