VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FontItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IDrawListItem

Private m_oDefault As IDrawListItem

Private Sub Class_Initialize()

   ' Create a default drawer object
   Set m_oDefault = New DefaultItemDrawer
   
End Sub

Private Sub IDrawListItem_DrawItem( _
   ByVal Item As ListItem, _
   ByVal Selected As Boolean, _
   ByVal Focused As Boolean, _
   ByVal Canvas As Canvas)
   
   ' Create a font using the item text
   ' as the font name
   Set Canvas.Font = New StdFont
   With Canvas.Font
      .Name = Item.Text
      .Size = 8
   End With
   
   ' Call the default renderer
   m_oDefault.DrawItem Item, Selected, Focused, Canvas

End Sub

Private Sub IDrawListItem_MeasureItem( _
   ByVal Item As ListItem, _
   ByRef Height As Long, _
   ByVal Canvas As Canvas)
   
   ' Call the default renderer
   m_oDefault.MeasureItem Item, Height, Canvas
   
End Sub
