VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsNyx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Const tWin As String = "8A8D8E9A9D9EBCBE8F9C9FA5B9"
Const tISO As String = "A9ABAEB9BBBEA5B5AFB6BFA1B1"

Private Type tProxy
            sUser As String
            sPassword As String
            sServer As String
            lPort As Long
End Type

Dim objDOM As New MSXML2.DOMDocument
'Dim objNode       As MSXML2.IXMLDOMNode
'Dim objRoot       As MSXML2.IXMLDOMElement
'Dim objTitleNode  As MSXML2.IXMLDOMNode
'Dim objUrlNode    As MSXML2.IXMLDOMNode
'Dim objTimeNode   As MSXML2.IXMLDOMNode
'Dim objAuthorNode As MSXML2.IXMLDOMNode
Dim tProxySetting As tProxy
Dim s_Error As String

Public Sub SetProxy(sUser As String, sPassword As String, Optional sServer As String, Optional lPort As Long)
    With tProxySetting
        .sUser = sUser
        .sPassword = sPassword
        .sServer = sServer
        .lPort = lPort
    End With
End Sub

Public Function LoadNyxData(sUser As String, sPassword As String) As Boolean
    Dim objXML As New MSXML2.XMLHTTP
    Dim ret As Boolean
    Dim sTmp As String
    
    'objXML.open "GET", "http://nyx.nyx.cz/files/klient-protokol.xml", False
    objXML.open "POST", "http://www.nyx.cz/code/client.php", False, tProxySetting.sUser, tProxySetting.sPassword
    objXML.setRequestHeader "pragma", "no-cache"
    objXML.setRequestHeader "cache-control", "no-cache"
    objXML.setRequestHeader "User-Agent:", "fNyx2.0TESTVERSION"
    objXML.setRequestHeader "Accept-Language:", "cs"
    objXML.setRequestHeader "Content-type", "application/x-www-form-urlencoded"

    'With tProxySetting
    '    If .sUser <> "" Then objXML.setRequestHeader "Proxy-Autentification", Base64Enc(.sUser & ":" & .sPassword)
    'End With
    objXML.send "loguser=" & sUser & "&logpass=" & sPassword
    
    If objXML.Status = 407 Then
        s_Error = "Proxy server vyaduje login a heslo!"
        Exit Function
    End If
    If objXML.Status = 403 Then
        s_Error = "Proxy serveru byl zadn patn login i heslo!"
        Exit Function
    End If

    'MsgBox objXML.responseText
    'Clipboard.SetText objXML.responseText

    objDOM.async = False
    ret = objDOM.loadXML(ISO2Win(objXML.responseText))
    LoadNyxData = ret
    objDOM.save App.Path & "\debuge.xml"
    
    If Not ret Then
        s_Error = "Chyba pi parsovn XML dokumentu: " & objDOM.parseError.reason
    End If
    
    On Error Resume Next
    sTmp = ""
    sTmp = objDOM.selectSingleNode("//info/page/error").Text
    On Error GoTo 0
    If sTmp <> "" Then
        s_Error = "Nyx hls: " & objDOM.selectSingleNode("//info/page/error").Text
        LoadNyxData = False
    End If
    
    'MsgBox objXML.responseText
    'MsgBox Mid(objXML.responseText, 500)
    'MsgBox objDOM.parseError.reason
    Set objXML = Nothing
End Function

Public Function GetXMLDataList(sPath As String) As MSXML2.IXMLDOMNodeList
    'On Error Resume Next
    'Dim objNodeList As MSXML2.IXMLDOMNodeList
    Dim objRoot As MSXML2.IXMLDOMElement
    
    Set objRoot = objDOM.documentElement
    Set GetXMLDataList = objRoot.selectNodes(sPath)
    Set objRoot = Nothing
End Function

Public Function GetXMLDataSingle(sPath As String) As MSXML2.IXMLDOMNode
    On Error Resume Next
    'Dim objNodeList As MSXML2.IXMLDOMNodeList
    Dim objRoot As MSXML2.IXMLDOMElement
    
    Set objRoot = objDOM.documentElement
    Set GetXMLDataSingle = objRoot.selectSingleNode(sPath)
    Set objRoot = Nothing
End Function

Public Function Error() As String
    Error = s_Error
End Function

'---------------------------------------------------------------------------------
' Podpurne funkce

Private Function Base64Enc(sData As String) As String
    'Base64 Conversion
    'Example:
    'Dim sMyConv As String
    'sMyConv = Base64Enc("Hello =)")
    On Error Resume Next
    Dim x As Long
    Dim y As Long
    Dim nByte As Long
    Dim nAsc As Long
    Dim sBin As String
    Dim sRet As String
    Dim sByte As String
    Dim nIncr As Integer
    'Convert the data to standard
    'base-2 binary.

    For x = 1 To Len(sData)
        DoEvents
            nByte = CLng(Asc(Mid(sData, x, 1)))
            For y = 1 To 8
                nIncr = CInt(2 ^ (8 - y))
                If CLng(nByte) - CLng(nIncr) >= 0 Then
                    nByte = nByte - CLng(nIncr)
                    sBin = sBin & "1"
                Else: sBin = sBin & "0"
                End If
            Next y
        Next x
        'Check to see if the conversion was comp
        '     leted
        'and if so, encode the data using the Ba
        '     se64
        'algorithm.
        If CLng(Len(sBin) Mod 8) = 0 Then
            'Binary conversion ok!, parse
            'every 6 bits of data.
            For x = 1 To Len(sBin) Step 6
                DoEvents
                    sByte = Mid(sBin, x, 6)
                    For y = 1 To Len(sByte)
                        DoEvents
                        nByte = Val(Mid(sByte, y, 1))
                        If Not nByte = 0 Then
                            nAsc = nAsc + CInt(2 ^ (6 - (y)))
                        End If
                    Next y
                    'Base64 Conversion:

                    Select Case (nAsc + 65)
                            Case Is > 90 'Either lowercase or numeric
                                If (nAsc + 71) > 122 Then
                                    sByte = Chr(nAsc - 4)
                                Else
                                    sByte = Chr(nAsc + 71)
                                End If
                            Case Is <= 90 'Uppercase
                                sByte = Chr(nAsc + 65)
                    End Select
                    'Append new characters to the final
                    'string and reset temporary variables.
                    sRet = sRet & sByte
                    nAsc = 0
                Next x
            End If
            'Finished, output the data to the
            'function variable.
            Base64Enc = sRet
End Function

Public Function Win2ISO(sText) As String
    Dim sTmp As String
    Dim i As Long, i2 As Long
    sTmp = sText
            
    For i = 1 To Len(sTmp)
        For i2 = 1 To Len(tWin) / 2
            If CLng("&H" & Mid(tWin, i2 * 2 - 1, 2)) = Asc(Mid(sTmp, i, 1)) Then
                Mid(sTmp, i, 1) = Chr(CLng("&H" & Mid(tISO, i2 * 2 - 1, 2)))
                Exit For
            End If
        Next i2
    Next i
    
    Win2ISO = sTmp
    sTmp = vbNullString
End Function

Public Function ISO2Win(sText) As String
    Dim sTmp As String
    Dim i As Long, i2 As Long
    sTmp = sText
        
    For i = 1 To Len(sTmp)
        For i2 = 1 To Len(tISO) / 2
            If CLng("&H" & Mid(tISO, i2 * 2 - 1, 2)) = Asc(Mid(sTmp, i, 1)) Then
                Mid(sTmp, i, 1) = Chr(CLng("&H" & Mid(tWin, i2 * 2 - 1, 2)))
                Exit For
            End If
        Next i2
    Next i
    
    ISO2Win = sTmp
    sTmp = vbNullString
End Function

