VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsNyx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetInputState Lib "user32" () As Long

Const tWin As String = "8A8D8E9A9D9EBCBE8F9C9FA5B9"
Const tISO As String = "A9ABAEB9BBBEA5B5AFB6BFA1B1"

Dim objDOM As New MSXML2.DOMDocument
Public objCache As New MSXML2.DOMDocument
Dim s_Error As String
Dim m_sAddRequest As String
Dim m_sUserAgent As String
Dim m_notFirstRun As Boolean

Dim arrLastFriends() As String

Public Event onNewMail(sNick As String, dTimeDate As Date, sText As String)
Public Event onError(sMessage As String)
Public Event onMailError(sMessage As String)
Public Event onRefresh()
Public Event onFriendOnline(sNick As String, bFirstRun As Boolean)
Public Event onFriendOffline(sNick As String, bFirstRun As Boolean)

Public Property Let UseSecureLogin(bUseSecureLogin As Boolean)
    WriteCacheText "//fenyx/setting/usesecurelogin", IIf(bUseSecureLogin, "1", "0")
End Property

Public Property Get UseSecureLogin() As Boolean
    UseSecureLogin = CBool(Val(ReadCacheText("//fenyx/setting/usesecurelogin")))
End Property

Public Property Let UserAgent(sUserAgent As String)
    m_sUserAgent = sUserAgent
End Property

Public Property Get UserAgent() As String
    UserAgent = m_sUserAgent
End Property

Public Property Let UserName(sUserName As String)
    WriteCacheText "//fenyx/setting/user", sUserName
End Property

Public Property Get UserName() As String
    UserName = ReadCacheText("//fenyx/setting/user")
End Property

Public Property Get Password() As String
    Password = Decrypt(ReadCacheText("//fenyx/setting/password"))
End Property

Public Property Let Password(sPassword As String)
    WriteCacheText "//fenyx/setting/password", Encrypt(sPassword)
End Property

Public Property Let UseProxy(bUseProxy As Boolean)
    WriteCacheText "//fenyx/setting/useproxy", IIf(bUseProxy, "1", "0")
End Property

Public Property Get UseProxy() As Boolean
    UseProxy = CBool(Val(ReadCacheText("//fenyx/setting/useproxy")))
End Property

Public Property Let ProxyServer(sProxyServer As String)
    WriteCacheText "//fenyx/setting/proxyserver", sProxyServer
End Property

Public Property Get ProxyServer() As String
    ProxyServer = ReadCacheText("//fenyx/setting/proxyserver")
End Property

Public Property Let ProxyUserName(sProxyUserName As String)
    WriteCacheText "//fenyx/setting/proxy/user", sProxyUserName
End Property

Public Property Get ProxyUserName() As String
    ProxyUserName = ReadCacheText("//fenyx/setting/proxy/user")
End Property

Public Property Get ProxyPassword() As String
    ProxyPassword = Decrypt(ReadCacheText("//fenyx/setting/proxy/password"))
End Property

Public Property Let ProxyPassword(sProxyPassword As String)
    WriteCacheText "//fenyx/setting/proxy/password", Encrypt(sProxyPassword)
End Property

Public Function GetSetting(sKey As String) As String
    GetSetting = ReadCacheText("//fenyx/setting/" & sKey)
End Function

Public Sub SetSetting(sKey As String, sValue As String)
    WriteCacheText "//fenyx/setting/" & sKey, sValue
End Sub

Public Function Refresh() As Boolean
    On Error Resume Next
    Dim objHTTP As clsDownloader
    Dim ret As Boolean
    Dim sTmp As String
    Dim objList As IXMLDOMNodeList
    Dim objItem As IXMLDOMNode
    Dim fNum As Long
    Dim tmpArr() As Byte
    Dim i As Long
    Dim bTmp As Boolean
    Dim url As String
    Dim lLastGenerated As Double
    
    Set objHTTP = New clsDownloader
    
    If Me.UseProxy Then
        objHTTP.ProxyServer = Me.ProxyServer
        objHTTP.ProxyUserName = Me.ProxyUserName
        objHTTP.ProxyPassword = Me.ProxyPassword
    End If
    
    On Error Resume Next
    lLastGenerated = 0
    lLastGenerated = Val(Me.GetXMLDataSingle("//info/page/generated").text)
    On Error GoTo 0
    
    'Testovaci XMLko http://nyx.nyx.cz/files/klient-protokol.xml
    
    url = csClientURL_HTTP
    If Me.UseSecureLogin Then url = csClientURL_HTTPS
    
    objHTTP.OpenUrlPOST url, Me.ProxyUserName, Me.ProxyPassword, "loguser=" & URLEncode(Me.UserName) & "&logpass=" & URLEncode(Me.Password), _
    "User-Agent:" & m_sUserAgent & vbCrLf & _
    "Accept-Language: cs" & vbCrLf & _
    "Content-type: application/x-www-form-urlencoded"
    
    m_sAddRequest = ""
    If objHTTP.Status = 407 Or objHTTP.Status = 12031 Then
        s_Error = "Proxy server vyaduje login a heslo!"
        RaiseEvent onError(s_Error)
        GoTo quit
    End If
    If objHTTP.Status = 403 Then
        s_Error = "Proxy serveru byl zadn patn login i heslo!"
        RaiseEvent onError(s_Error)
        GoTo quit
    End If
    If objHTTP.Status = 0 Then
        s_Error = "Nepovedlo se nalzt server NYX.CZ. V ppad, e je nastaven proxy server, nepovedlo se pipojit na proxy server."
        RaiseEvent onError(s_Error)
        GoTo quit
    End If
    If objHTTP.Status <> 200 Then
        s_Error = "Nepovedlo se pijmout sprvn data." & vbCrLf & "Status: " & CStr(objHTTP.Status) & " " & objHTTP.StatusText
        RaiseEvent onError(s_Error)
        GoTo quit
    End If


    objDOM.async = False

    tmpArr = objHTTP.responseBody
    ret = objDOM.loadXML(ByteArrayToString(tmpArr))
    'ret = objDOM.loadXML(objHTTP.responseText)
    Refresh = ret
    
    If bDebuge Then
        fNum = FreeFile
        On Error Resume Next
        Kill AppDir & "debuge.txt"
        On Error GoTo 0
        Open AppDir & "debuge.txt" For Binary As fNum
        Put fNum, , ByteArrayToString(tmpArr) 'EncodeUTF8(ByteArrayToString(tmpArr))
        Close fNum
    End If
    
    If Not ret Then
        s_Error = "Chyba pi parsovn XML dokumentu: " & objDOM.parseError.reason & vbCrLf & "adek: " & objDOM.parseError.Line & vbCrLf & "Sloupec: " & objDOM.parseError.linepos & vbCrLf & "Zdrojov text: " & objDOM.parseError.srcText
        RaiseEvent onError(s_Error)
        GoTo quit
    End If
    
    If Val(Me.GetXMLDataSingle("//info/page/generated").text) = 0 Then
        If LCase(Me.GetXMLDataSingle("//info/page/cached").text) <> "yes" Then lLastGenerated = Val(Me.GetXMLDataSingle("//info/page/generated").text)
        If lLastGenerated = 0 Then lLastGenerated = Timestamp()
        Me.GetXMLDataSingle("//info/page/generated").text = CStr(lLastGenerated)
    End If
    
    On Error Resume Next
    sTmp = ""
    sTmp = objDOM.selectSingleNode("//info/page/error").text
    On Error GoTo 0
    If sTmp <> "" Then
        s_Error = "Nyx hls: " & objDOM.selectSingleNode("//info/page/error").text
        RaiseEvent onError(s_Error)
        Refresh = False
        GoTo quit
    End If
        
    'Parsovani Mailu
    Set objList = GetXMLDataList("//info/mail")
    If objList.Length <> 0 Then
        For Each objItem In objList(0).selectNodes("message")
            With objItem
                AddMailToCache .selectSingleNode("username").text, Val(.selectSingleNode("time").text), .selectSingleNode("text").text
                RaiseEvent onNewMail(.selectSingleNode("username").text, TimestampToDate(Val(.selectSingleNode("time").text)), .selectSingleNode("text").text)
            End With
            myDoEvents
        Next
    End If
    
    Set objList = GetXMLDataList("//info/friends/friend")
    If objList.Length <> 0 Then
        For Each objItem In objList
            With objItem
                If Not IsInArray(arrLastFriends, .selectSingleNode("username").text) Then
                    RaiseEvent onFriendOnline(.selectSingleNode("username").text, Not m_notFirstRun)
                    ReDim Preserve arrLastFriends(0 To arrCount(arrLastFriends))
                    arrLastFriends(arrCount(arrLastFriends) - 1) = .selectSingleNode("username").text
                End If
            End With
            myDoEvents
        Next
    End If
    
    If arrCount(arrLastFriends) <> 0 Then
        For i = 0 To arrCount(arrLastFriends) - 1
            'Mensi hack -musi se poladit - misto klasickeho for tam dat for each
            If arrCount(arrLastFriends) - 1 < i Then Exit For
            sTmp = arrLastFriends(i)
            For Each objItem In objList
                With objItem
                    If arrLastFriends(i) = objItem.selectSingleNode("username").text Then
                        sTmp = ""
                        Exit For
                    End If
                End With
                myDoEvents
            Next
            If sTmp <> "" Then
                RaiseEvent onFriendOffline(sTmp, Not m_notFirstRun)
                DeleteArrayItem arrLastFriends, i
            End If
            myDoEvents
        Next i
    End If
    
    

    RaiseEvent onRefresh
    m_notFirstRun = True
quit:
    Set objList = Nothing
    Set objItem = Nothing
    Set objHTTP = Nothing
End Function

Public Function SendMail(ByVal sRecipient As String, ByVal sText As String) As String
    On Error Resume Next
    Dim objHTTP As clsDownloader
    Dim ret As Boolean
    Dim sReturn As String
    Dim sTmp As String
    Dim objMailList As IXMLDOMNodeList
    Dim objMailItem As IXMLDOMNode
    Dim tmpArr() As Byte
    Dim url As String
    
    Set objHTTP = New clsDownloader
    
    If Me.UseProxy Then
        objHTTP.ProxyServer = Me.ProxyServer
        objHTTP.ProxyUserName = Me.ProxyUserName
        objHTTP.ProxyPassword = Me.ProxyPassword
    End If
    
    url = csClientURL_HTTP
    If Me.UseSecureLogin Then url = csClientURL_HTTPS
    
    objHTTP.OpenUrlPOST url, Me.ProxyUserName, Me.ProxyPassword, "loguser=" & Me.UserName & "&logpass=" & Me.Password & "&recipient=" & URLEncode(sRecipient) & "&message=" & URLEncode(EncodeUTF8(sText)), _
    "User-Agent:" & m_sUserAgent & vbCrLf & _
    "Accept-Language: cs" & vbCrLf & _
    "Content-type: application/x-www-form-urlencoded"
    
    If objHTTP.Status = 407 Then
        sReturn = "Proxy server vyaduje login a heslo!"
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If
    If objHTTP.Status = 403 Then
        sReturn = "Proxy serveru byl zadn patn login i heslo!"
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If
    If objHTTP.Status <> 200 Then
        sReturn = "Nepovedlo se pijmout sprvn data." & vbCrLf & "Status: " & CStr(objHTTP.Status) & " " & objHTTP.StatusText
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If


    objDOM.async = False
    tmpArr = StrConv(objHTTP.responseText, vbFromUnicode)
    ret = objDOM.loadXML(ByteArrayToString(tmpArr))
    SendMail = ret
     
    If Not ret Then
        sReturn = "Chyba pi parsovn XML dokumentu: " & objDOM.parseError.reason & vbCrLf & "adek: " & objDOM.parseError.Line & vbCrLf & "Sloupec: " & objDOM.parseError.linepos & vbCrLf & "Zdrojov text: " & objDOM.parseError.srcText
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If
    
    On Error Resume Next
    sTmp = ""
    sTmp = objDOM.selectSingleNode("//info/page/error").text
    On Error GoTo 0
    If sTmp <> "" Then
        sReturn = "Nyx hls: " & objDOM.selectSingleNode("//info/page/error").text
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If
        
    On Error Resume Next
    sTmp = ""
    sTmp = objDOM.selectSingleNode("//info/page/mailerror").text
    On Error GoTo 0
    If sTmp <> "" Then
        sReturn = "Nyx hls: " & objDOM.selectSingleNode("//info/page/mailerror").text
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If

quit:
    SendMail = sReturn
    Set objMailList = Nothing
    Set objHTTP = Nothing
End Function

Public Function SendMailFromWeb(ByVal sRecipient As String, ByVal sText As String) As String
    On Error Resume Next
    Dim objHTTP As clsDownloader
    Dim ret As Boolean
    Dim sReturn As String
    Dim sTmp As String
    Dim objMailList As IXMLDOMNodeList
    Dim objMailItem As IXMLDOMNode
    Dim tmpArr() As Byte
    Dim url As String
    
    If Trim(Me.GetSetting("webpassword")) = "" Then
        sReturn = "Nen vyplnno webov heslo v nastaven!"
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If
    
    Set objHTTP = New clsDownloader
    
    If Me.UseProxy Then
        objHTTP.ProxyServer = Me.ProxyServer
        objHTTP.ProxyUserName = Me.ProxyUserName
        objHTTP.ProxyPassword = Me.ProxyPassword
    End If
    
    url = IIf(Me.UseSecureLogin, "https", "http") & "://www.nyx.cz/code/index.php?login=1;l=mailexec"
    
    objHTTP.OpenUrlPOST url, Me.ProxyUserName, Me.ProxyPassword, "loguser=" & Me.UserName & "&logpass=" & Me.GetSetting("webpassword") & "&send=odeslat&recipient=" & URLEncode(sRecipient) & "&message=" & URLEncode(EncodeUTF8(sText)), _
    "User-Agent:" & m_sUserAgent & vbCrLf & _
    "Accept-Language: cs" & vbCrLf & _
    "Content-type: application/x-www-form-urlencoded"
    
    If objHTTP.Status = 407 Then
        sReturn = "Proxy server vyaduje login a heslo!"
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If
    If objHTTP.Status = 403 Then
        sReturn = "Proxy serveru byl zadn patn login i heslo!"
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If
    If objHTTP.Status <> 200 Then
        sReturn = "Nepovedlo se pijmout sprvn data." & vbCrLf & "Status: " & CStr(objHTTP.Status) & " " & objHTTP.StatusText
        RaiseEvent onMailError(sReturn)
        GoTo quit
    End If
quit:
    SendMailFromWeb = sReturn
    Set objMailList = Nothing
    Set objHTTP = Nothing
End Function

Public Function getNyxPage(ByVal sQuery As String) As String
    On Error Resume Next
    Dim objHTTP As clsDownloader
    Dim ret As Boolean
    Dim sReturn As String
    Dim sTmp As String
    Dim objMailList As IXMLDOMNodeList
    Dim objMailItem As IXMLDOMNode
    Dim tmpArr() As Byte
    Dim url As String
    
    If Trim(Me.GetSetting("webpassword")) = "" Then
        sReturn = "Nen vyplnno webov heslo v nastaven!"
        RaiseEvent onError(sReturn)
        GoTo quit
    End If
    
    Set objHTTP = New clsDownloader
    
    If Me.UseProxy Then
        objHTTP.ProxyServer = Me.ProxyServer
        objHTTP.ProxyUserName = Me.ProxyUserName
        objHTTP.ProxyPassword = Me.ProxyPassword
    End If
    
    url = IIf(Me.UseSecureLogin, "https", "http") & "://www.nyx.cz/code/index.php?login=1;" & sQuery
    
    objHTTP.OpenUrlPOST url, Me.ProxyUserName, Me.ProxyPassword, "loguser=" & Me.UserName & "&logpass=" & Me.GetSetting("webpassword"), _
    "User-Agent:" & m_sUserAgent & vbCrLf & _
    "Accept-Language: cs" & vbCrLf & _
    "Content-type: application/x-www-form-urlencoded"
    
    If objHTTP.Status = 407 Then
        sReturn = "Proxy server vyaduje login a heslo!"
        RaiseEvent onError(sReturn)
        GoTo quit
    End If
    If objHTTP.Status = 403 Then
        sReturn = "Proxy serveru byl zadn patn login i heslo!"
        RaiseEvent onError(sReturn)
        GoTo quit
    End If
    If objHTTP.Status <> 200 Then
        sReturn = "Nepovedlo se pijmout sprvn data." & vbCrLf & "Status: " & CStr(objHTTP.Status) & " " & objHTTP.StatusText
        RaiseEvent onError(sReturn)
        GoTo quit
    End If

    sReturn = DecodeUTF8(StrConv(objHTTP.responseBody, vbUnicode))
quit:
    getNyxPage = sReturn
    Set objMailList = Nothing
    Set objHTTP = Nothing
End Function


Public Function GetUserPicture(sNick As String) As StdPicture
    Dim objHTTP As clsDownloader
    Dim tmpArr() As Byte
    Dim tmpPic As StdPicture
    Dim fNum As Long
    On Error GoTo 0
    
    'If Dir(AppDir & "cache\icons\" & sNick & ".gif") <> "" Then
    '    Set GetUserPicture = LoadPicture(AppDir & "cache\icons\" & sNick & ".gif")
    '    Exit Function
    'End If
    
    Set objHTTP = New clsDownloader
    
    If Me.UseProxy Then
        objHTTP.ProxyServer = Me.ProxyServer
        objHTTP.ProxyUserName = Me.ProxyUserName
        objHTTP.ProxyPassword = Me.ProxyPassword
    End If
    
    objHTTP.OpenUrlGET csPicturesURL & Left(sNick, 1) & "/" & sNick & ".gif", Me.ProxyUserName, Me.ProxyPassword, "", _
    "User-Agent: " & m_sUserAgent & vbCrLf & _
    "Accept-Language: cs" & vbCrLf & _
    "Accept: image/gif,image/jpg,image/bmp"
    If objHTTP.Status <> 200 Then
        tmpArr = LoadResData("krizek", 10)
        Set GetUserPicture = LoadImage(tmpArr)
        Exit Function
    End If

    tmpArr = objHTTP.responseBody
    
    'On Error Resume Next
    'fNum = FreeFile
    'Open AppDir & "cache\icons\" & sNick & ".gif" For Binary As fNum
    '    Put fNum, , tmpArr
    'Close fNum
    'On Error GoTo 0
    
    Set tmpPic = LoadImage(tmpArr)
    If tmpPic.Handle = 0 Then
        tmpArr = LoadResData(200, "BITMAP")
        Set GetUserPicture = LoadImage(tmpArr)
    Else
        Set GetUserPicture = tmpPic
    End If
    Set tmpPic = Nothing
    Set objHTTP = Nothing
End Function

Public Function GetXMLDataList(sPath As String) As IXMLDOMNodeList
    On Error Resume Next
    'Dim objNodeList As MSXML2.IXMLDOMNodeList
    Dim objRoot As IXMLDOMElement
    
    Set objRoot = objDOM.documentElement
    Set GetXMLDataList = objRoot.selectNodes(sPath)
    Set objRoot = Nothing
End Function

Public Function GetXMLDataSingle(sPath As String) As IXMLDOMNode
    On Error Resume Next
    'Dim objNodeList As MSXML2.IXMLDOMNodeList
    Dim objRoot As IXMLDOMElement
    
    Set objRoot = objDOM.documentElement
    Set GetXMLDataSingle = objRoot.selectSingleNode(sPath)
    Set objRoot = Nothing
End Function

Public Function Error() As String
    Error = s_Error
End Function

Public Function ReadCacheText(sPath As String) As String
    On Error Resume Next
    ReadCacheText = objCache.selectSingleNode(sPath).text
End Function

Public Sub WriteCacheText(sPath As String, sText As String)
    Dim objNode As IXMLDOMNode
    Dim arrPath() As String
    Dim sTmp As String
    Dim i As Long
    
    sTmp = sPath
    If Left(sTmp, 2) = "//" Then sTmp = Mid(sTmp, 3)
    
    If objCache.selectNodes(sPath).Length <> 0 Then
        objCache.selectSingleNode(sPath).text = sText
        Exit Sub
    End If
    
    If InStr(sTmp, "/") = 0 Then
        objCache.appendChild(objCache.createElement(sTmp)).text = sText
    Else
        arrPath = Split(sTmp, "/")
        If objCache.selectNodes(arrPath(0)).Length <> 0 Then
            Set objNode = objCache.selectSingleNode(arrPath(0))
        Else
            Set objNode = objCache.appendChild(objCache.createElement(arrPath(0)))
        End If
        For i = 1 To UBound(arrPath)
            If objNode.selectNodes(arrPath(i)).Length <> 0 Then
                Set objNode = objNode.selectSingleNode(arrPath(i))
            Else
                Set objNode = objNode.appendChild(objCache.createElement(arrPath(i)))
            End If
            myDoEvents
        Next i
        objNode.text = sText
    End If
End Sub

Public Function SetCacheAttribute(sPath As String, sName As String, sValue As String) As Boolean
    Dim objTmp As IXMLDOMAttribute

    On Error GoTo err
    objCache.selectSingleNode(sPath).Attributes.getNamedItem(sName).text = sValue
    GoTo ok
err:
    On Error GoTo err2
    Set objTmp = objCache.createAttribute(sName)
    objTmp.Value = sValue
    objCache.selectSingleNode(sPath).Attributes.setNamedItem objTmp
    Set objTmp = Nothing
    GoTo ok
ok:
    SetCacheAttribute = True
    Exit Function
err2:
    SetCacheAttribute = False
End Function

Public Function GetCacheAttribute(sPath As String, sName As String) As String
    On Error Resume Next
    GetCacheAttribute = objCache.selectSingleNode(sPath).Attributes.getNamedItem(sName).text
End Function

Public Sub AddMailToCache(sFrom As String, lTimeDate As Long, sText As String)
    Dim objFrom As IXMLDOMElement
    Dim objTimeDate As IXMLDOMElement
    Dim objText As IXMLDOMElement
    Dim objTempText As IXMLDOMText
    Dim objMessage As IXMLDOMElement
    Dim objNode As IXMLDOMNode
    
    Set objFrom = objCache.createElement("from")
    Set objTempText = objCache.createTextNode(sFrom)
    objFrom.appendChild objTempText
    
    Set objTimeDate = objCache.createElement("time")
    Set objTempText = objCache.createTextNode(CStr(lTimeDate))
    objTimeDate.appendChild objTempText
    
    Set objText = objCache.createElement("text")
    Set objTempText = objCache.createTextNode(sText)
    objText.appendChild objTempText
    
    Set objMessage = objCache.createElement("message")
    With objMessage
        .appendChild objFrom
        .appendChild objTimeDate
        .appendChild objText
    End With
    
    objCache.selectSingleNode("//fenyx/mail").appendChild objMessage
End Sub

Public Function ReadMail(lItemIndex As Long, sFrom As String, lTimeDate As Long, sText As String, Optional bReaded As Boolean = False) As Boolean
    On Error GoTo err
    Dim objNode As IXMLDOMNode
    
    Set objNode = objCache.selectSingleNode("//fenyx/mail/message[" & CStr(lItemIndex) & "]")
    'bReaded = IIf(objNode.Attributes.getNamedItem("readed").Text = "true", True, False)
    With objNode
        'nemusi byt nastaveno
        bReaded = False
        On Error Resume Next
        bReaded = CBool(objNode.Attributes.getNamedItem("readed").text)
        On Error GoTo err
        sFrom = objNode.selectSingleNode("from").text
        lTimeDate = Val(objNode.selectSingleNode("time").text)
        sText = objNode.selectSingleNode("text").text
    End With
    ReadMail = True
    Exit Function
err:
    ReadMail = False
End Function

Public Function IsMailReaded(lItemIndex As Long) As Boolean
    On Error GoTo err
    Dim objNode As IXMLDOMNode
    
    Set objNode = objCache.selectSingleNode("//fenyx/mail/message[" & CStr(lItemIndex) & "]")
    IsMailReaded = CBool(objNode.Attributes.getNamedItem("readed").text)
    Set objNode = Nothing
    Exit Function
err:
    Set objNode = Nothing
    IsMailReaded = False
End Function


Public Function SetMailReaded(lItemIndex As Long, bReaded As Boolean) As Boolean
    Dim objTmp As IXMLDOMAttribute

    On Error GoTo err
    objCache.selectSingleNode("//fenyx/mail/message[" & CStr(lItemIndex) & "]").Attributes.getNamedItem("readed").text = CStr(bReaded)
    GoTo ok
err:
    On Error GoTo err2
    Set objTmp = objCache.createAttribute("readed")
    objTmp.Value = CStr(bReaded)
    objCache.selectSingleNode("//fenyx/mail/message[" & CStr(lItemIndex) & "]").Attributes.setNamedItem objTmp
    Set objTmp = Nothing
    GoTo ok
ok:
    SetMailReaded = True
    Exit Function
err2:
    SetMailReaded = False
End Function

Public Function DeleteMail(lItemIndex As Long) As Boolean
    On Error GoTo err
    Dim objNode As IXMLDOMNode
    
    Set objNode = objCache.selectSingleNode("//fenyx/mail/message[" & CStr(lItemIndex) & "]")
    objNode.parentNode.removeChild objNode
    
    DeleteMail = True
    Exit Function
err:
    DeleteMail = False
End Function

Public Property Get MailUnreadedCount() As Long
    On Error Resume Next
    Dim i As Long
    Dim lTmp As Long
    MailUnreadedCount = 0
    lTmp = 0
    For i = 0 To objCache.selectNodes("//fenyx/mail/message").Length - 1
        If Not CBool(objCache.selectSingleNode("//fenyx/mail/message[" & CStr(i) & "]").Attributes.getNamedItem("readed").text) Then
            lTmp = lTmp + 1
            myDoEvents
        End If
    Next i
    MailUnreadedCount = lTmp
End Property

Public Property Get MailCount() As Long
    On Error Resume Next
    MailCount = 0
    MailCount = objCache.selectNodes("//fenyx/mail/message").Length
End Property

Public Property Get NewTopicsCount() As Long
    Dim objNodeList As IXMLDOMNodeList
    Dim objNodeList2 As IXMLDOMNodeList
    Dim objNode As IXMLDOMNode
    Dim objNode2 As IXMLDOMNode
    Dim lCount As Long
    
    lCount = 0
    Set objNodeList = objDOM.documentElement.selectNodes("//info/boards/category")
    For Each objNode In objNodeList
        Set objNodeList2 = objNode.selectNodes("board")
        For Each objNode2 In objNodeList2
            lCount = lCount + Val(objNode2.Attributes.getNamedItem("new").text)
            myDoEvents
        Next
        myDoEvents
    Next
    NewTopicsCount = lCount
End Property

Public Sub CacheInit()
    On Error Resume Next
    Dim objDummy As IXMLDOMElement
    If objCache.selectNodes("//fenyx").Length = 0 Then
        objCache.appendChild objCache.createElement("fenyx")
    End If
    If objCache.selectNodes("//fenyx/setting").Length = 0 Then
        objCache.selectSingleNode("//fenyx").appendChild objCache.createElement("setting")
    End If
    If objCache.selectNodes("//fenyx/mail").Length = 0 Then
        objCache.selectSingleNode("//fenyx").appendChild objCache.createElement("mail")
    End If
    If objCache.selectNodes("//fenyx/setting/windows").Length = 0 Then
        objCache.selectSingleNode("//fenyx/setting").appendChild objCache.createElement("windows")
    End If
    If objCache.selectNodes("//fenyx/setting/windows/main").Length = 0 Then
        objCache.selectSingleNode("//fenyx/setting/windows").appendChild objCache.createElement("main")
    End If
    If objCache.selectNodes("//fenyx/setting/windows/topics").Length = 0 Then
        objCache.selectSingleNode("//fenyx/setting/windows").appendChild objCache.createElement("topics")
    End If
    If objCache.selectNodes("//fenyx/setting/windows/mail").Length = 0 Then
        objCache.selectSingleNode("//fenyx/setting/windows").appendChild objCache.createElement("mail")
    End If
    If objCache.selectNodes("//fenyx/setting/modes").Length = 0 Then
        objCache.selectSingleNode("//fenyx/setting").appendChild objCache.createElement("modes")
    End If
    If Val(Me.GetSetting("refreshtime")) < 60 Then Me.SetSetting "refreshtime", "60"
    If InStr(objCache.xml, "<?xml") = 0 Then
        objCache.insertBefore objCache.createProcessingInstruction("xml", "version=""1.0"" encoding=""UTF-8"""), objCache.documentElement
    End If
    'On Error Resume Next
    'MkDir AppDir & "cache"
    'MkDir AppDir & "cache\icons"
    'On Error GoTo 0
End Sub

Public Function LoadCache(sFile As String) As Boolean
    objCache.async = True
    LoadCache = objCache.Load(sFile)
    Do
        DoEvents
        If objCache.parsed Then Exit Do
    Loop
End Function

Public Sub SaveCache(sFile As String)
    objCache.loadXML FormatXML(objCache.documentElement, 0)
    CacheInit
    objCache.Save sFile
End Sub

'---------------------------------------------------------------------------------
' Podpurne funkce

Private Function Base64Enc(sData As String) As String
    'Base64 Conversion
    'Example:
    'Dim sMyConv As String
    'sMyConv = Base64Enc("Hello =)")
    On Error Resume Next
    Dim x As Long
    Dim Y As Long
    Dim nByte As Long
    Dim nAsc As Long
    Dim sBin As String
    Dim sRet As String
    Dim sByte As String
    Dim nIncr As Integer
    'Convert the data to standard
    'base-2 binary.

    For x = 1 To Len(sData)
        myDoEvents
            nByte = CLng(Asc(Mid(sData, x, 1)))
            For Y = 1 To 8
                nIncr = CInt(2 ^ (8 - Y))
                If CLng(nByte) - CLng(nIncr) >= 0 Then
                    nByte = nByte - CLng(nIncr)
                    sBin = sBin & "1"
                Else: sBin = sBin & "0"
                End If
            Next Y
        Next x
        'Check to see if the conversion was comp
        '     leted
        'and if so, encode the data using the Ba
        '     se64
        'algorithm.
        If CLng(Len(sBin) Mod 8) = 0 Then
            'Binary conversion ok!, parse
            'every 6 bits of data.
            For x = 1 To Len(sBin) Step 6
                myDoEvents
                    sByte = Mid(sBin, x, 6)
                    For Y = 1 To Len(sByte)
                        myDoEvents
                        nByte = Val(Mid(sByte, Y, 1))
                        If Not nByte = 0 Then
                            nAsc = nAsc + CInt(2 ^ (6 - (Y)))
                        End If
                    Next Y
                    'Base64 Conversion:

                    Select Case (nAsc + 65)
                            Case Is > 90 'Either lowercase or numeric
                                If (nAsc + 71) > 122 Then
                                    sByte = Chr(nAsc - 4)
                                Else
                                    sByte = Chr(nAsc + 71)
                                End If
                            Case Is <= 90 'Uppercase
                                sByte = Chr(nAsc + 65)
                    End Select
                    'Append new characters to the final
                    'string and reset temporary variables.
                    sRet = sRet & sByte
                    nAsc = 0
                Next x
            End If
            'Finished, output the data to the
            'function variable.
            Base64Enc = sRet
End Function

Public Function Win2ISO(sText) As String
    Dim sTmp As String
    Dim i As Long, i2 As Long
    sTmp = sText
            
    For i = 1 To Len(sTmp)
        For i2 = 1 To Len(tWin) / 2
            If CLng("&H" & Mid(tWin, i2 * 2 - 1, 2)) = Asc(Mid(sTmp, i, 1)) Then
                Mid(sTmp, i, 1) = Chr(CLng("&H" & Mid(tISO, i2 * 2 - 1, 2)))
                Exit For
            End If
        Next i2
    Next i
    
    Win2ISO = sTmp
    sTmp = vbNullString
End Function

Public Function ISO2Win(sText) As String
    Dim sTmp As String
    Dim i As Long, i2 As Long
    sTmp = sText
        
    For i = 1 To Len(sTmp)
        For i2 = 1 To Len(tISO) / 2
            If CLng("&H" & Mid(tISO, i2 * 2 - 1, 2)) = Asc(Mid(sTmp, i, 1)) Then
                Mid(sTmp, i, 1) = Chr(CLng("&H" & Mid(tWin, i2 * 2 - 1, 2)))
                Exit For
            End If
        Next i2
    Next i
    
    ISO2Win = sTmp
    sTmp = vbNullString
End Function

Private Function FormatXML(ptrNode As MSXML2.IXMLDOMNode, Optional iTabLevel As Integer = 0) As String
Dim bMixedTextNode As Boolean
Dim bHasOnlyATextNode As Boolean
Dim i As Integer

    With ptrNode
        Select Case .nodeType
        Case NODE_DOCUMENT, NODE_DOCUMENT_FRAGMENT
            'all child nodes of the document should be at the same indent Level
            'just iterate over them and recurse with 0 indent
            For i = 0 To .childNodes.Length - 1
                FormatXML = FormatXML & FormatXML(.childNodes(i))
            Next i
        
        Case NODE_TEXT
            'should render the same way the default IE5 stylesheet does for mixed content
            'figure out if we're in some mixed content

            'if this text node has any siblings it's in mixed content
            bMixedTextNode = (.parentNode.childNodes.Length > 1)
            
            'if mixed indent this string
            If bMixedTextNode Then FormatXML = String(iTabLevel, vbTab)

            'we're gonna strip out any tabs and carriage returns from the Text
            FormatXML = FormatXML & Trim(Replace(Replace(.xml, vbCrLf, " "), vbTab, " "))

            'if mixed add cariage return
            If bMixedTextNode Then FormatXML = FormatXML & vbCrLf

        Case NODE_ELEMENT
            If .hasChildNodes Then
                'if the node has only one child and
                'that child is text we won't add carriage return after opening tag
                bHasOnlyATextNode = (.childNodes(0).nodeType = NODE_TEXT) And (.childNodes.Length = 1)
            End If
            
            'open the start tag
            FormatXML = String(iTabLevel, vbTab) & "<" & .nodeName

            'recurse over the attributes
            For i = 0 To .Attributes.Length - 1
                FormatXML = FormatXML + FormatXML(.Attributes(i))
            Next i

            'properly close the start tag based on node's contents
            If Not .hasChildNodes Then       'no child nodes so it's an empty element
                FormatXML = FormatXML & "/>" & vbCrLf
                
            Else
                If bHasOnlyATextNode Then   'has only text for children - don't add carriage return
                    FormatXML = FormatXML & ">"
                Else                            'has child elements - add carriage return
                    FormatXML = FormatXML & ">" & vbCrLf
                End If
                
                'recurse if there's children
                For i = 0 To .childNodes.Length - 1
                    FormatXML = FormatXML & FormatXML(.childNodes(i), iTabLevel + 1)
                Next i
                
                'properly indent and add the end tag
                If Not bHasOnlyATextNode Then FormatXML = FormatXML & String(iTabLevel, vbTab)
                FormatXML = FormatXML & "</" & .nodeName & ">" & vbCrLf
                
            End If
                    
        Case NODE_COMMENT, NODE_CDATA_SECTION
            'if comment is on more than one line don't indent
            If InStr(1, .xml, vbCr) = 0 Then FormatXML = String(iTabLevel, vbTab)
            FormatXML = FormatXML & .xml & vbCrLf
        
        Case NODE_ATTRIBUTE
            'if there are double quotes in the attribute use single quotes to surrond the attr value
            If InStr(1, .text, Chr(34)) > 0 Then
                FormatXML = " " & .nodeName & "='" & .text & "'"
            Else
                FormatXML = " " & .nodeName & "=" & Chr(34) & .text & Chr(34)
            End If
        
        Case NODE_ENTITY
            'and we would never want entites expanded
            
        Case Else
            'all other node types should just return their xml (properly indented)
            'these include - entity refs, pi's, notations, doctypes
            FormatXML = String(iTabLevel, vbTab) & .xml & vbCrLf
            
        End Select
        
    End With

End Function

Public Function LoadImage( _
   ImageBytes() As Byte) As StdPicture
Dim oPersist As IPersistStream
Dim oStream As IStream
Dim lSize As Long
  
   ' Calculate the array size
   lSize = UBound(ImageBytes) - LBound(ImageBytes) + 1
   
   ' Create a stream object
   ' in global memory
   Set oStream = CreateStreamOnHGlobal(0, True)
   
   ' Write the header to the stream
   oStream.Write &H746C&, 4&
   
   ' Write the array size
   oStream.Write lSize, 4&
   
   ' Write the image data
   oStream.Write ImageBytes(LBound(ImageBytes)), lSize
   
   ' Move the stream position to
   ' the start of the stream
   oStream.Seek 0, STREAM_SEEK_SET
      
   ' Create a new empty picture object
   Set LoadImage = New StdPicture
   
   ' Get the IPersistStream interface
   ' of the picture object
   Set oPersist = LoadImage
   
   ' Load the picture from the stream
   oPersist.Load oStream
      
   ' Release the streamobject
   Set oStream = Nothing
   
End Function

Private Function URLEncode(sToEncode As String) As String
    Const URLValid = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 "
    Dim i As Integer
    Dim sRet As String
    Dim sTmp As String

    If Len(sToEncode) > 0 Then
        For i = 1 To Len(sToEncode)
            sTmp = Mid(sToEncode, i, 1)
            If InStr(1, URLValid, sTmp, vbBinaryCompare) = 0 Then sTmp = "%" & IIf(Asc(sTmp) < 16, "0" & Hex(Asc(sTmp)), Hex(Asc(sTmp)))
            AddText sRet, sTmp
        Next i
        sRet = Replace(sRet, " ", "+")
        URLEncode = sRet
    End If
    sRet = vbNullString
End Function

Private Sub AddText(ByRef sKam As String, sCo As String)
    Dim sTmp As String
    sTmp = Space(Len(sKam) + Len(sCo))
    
    If Len(sKam) <> 0 Then Mid(sTmp, 1, Len(sKam)) = sKam
    Mid(sTmp, Len(sKam) + 1, Len(sCo)) = sCo
    sKam = sTmp
    sTmp = vbNullString
End Sub


Private Sub Class_Initialize()
    m_sUserAgent = App.EXEName & " " & App.Major & "." & App.Minor & ".0." & App.Revision
    m_notFirstRun = False
End Sub

Private Function arrCount(arr() As String) As Long
    On Error GoTo quit
    arrCount = UBound(arr) + 1
    Exit Function
quit:
    arrCount = 0
End Function

Private Function IsInArray(arr() As String, sFind As String) As Boolean
    Dim i As Long
    For i = 0 To arrCount(arr) - 1
        If arr(i) = sFind Then
            IsInArray = True
            Exit Function
        End If
        myDoEvents
    Next i
    IsInArray = False
End Function

Private Sub DeleteArrayItem(ByRef arr() As String, lItem As Long)
    Dim i As Long
    For i = lItem To arrCount(arr) - 2
        arr(i) = arr(i + 1)
        myDoEvents
    Next i
    If arrCount(arr) - 1 = 0 Then
        Erase arr
    Else
        ReDim Preserve arr(0 To arrCount(arr) - 2)
    End If
End Sub

Private Sub myDoEvents()
        If GetInputState() <> 0 Then DoEvents
End Sub

Private Sub Class_Terminate()
    Set objDOM = Nothing
End Sub
