VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmTopics 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Kluby"
   ClientHeight    =   4944
   ClientLeft      =   60
   ClientTop       =   336
   ClientWidth     =   6876
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4944
   ScaleWidth      =   6876
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.TreeView treTopics 
      Height          =   4215
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   2655
      _ExtentX        =   4678
      _ExtentY        =   7430
      _Version        =   393217
      LabelEdit       =   1
      Style           =   6
      Appearance      =   1
   End
End
Attribute VB_Name = "frmTopics"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private bUnsafeResize As Boolean

Private Sub Form_Initialize()
    InitCommonControlsVB
    MakeClearType Me
End Sub

Private Sub Form_Load()
    'On Error Resume Next

    bUnsafeResize = True
    If Val(frmMain.nyx.GetSetting("windows/topics/top")) > 0 Then Me.Top = Val(frmMain.nyx.GetSetting("windows/topics/top")) * Screen.TwipsPerPixelY
    If Val(frmMain.nyx.GetSetting("windows/topics/left")) > 0 Then Me.Left = Val(frmMain.nyx.GetSetting("windows/topics/left")) * Screen.TwipsPerPixelX
    If Val(frmMain.nyx.GetSetting("windows/topics/height")) > 0 Then Me.Height = Val(frmMain.nyx.GetSetting("windows/topics/height")) * Screen.TwipsPerPixelY
    If Val(frmMain.nyx.GetSetting("windows/topics/width")) > 0 Then Me.Width = Val(frmMain.nyx.GetSetting("windows/topics/width")) * Screen.TwipsPerPixelX
    bUnsafeResize = False
    
    SetIconLong Me.hwnd, 241
    
    Call Me.RefreshList
End Sub

Private Sub Form_Resize()
    treTopics.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
    If Me.WindowState <> vbMinimized And Not bUnsafeResize Then
        frmMain.nyx.SetSetting "windows/topics/top", CStr(Me.Top / Screen.TwipsPerPixelY)
        frmMain.nyx.SetSetting "windows/topics/left", CStr(Me.Left / Screen.TwipsPerPixelX)
        frmMain.nyx.SetSetting "windows/topics/height", CStr(Me.Height / Screen.TwipsPerPixelY)
        frmMain.nyx.SetSetting "windows/topics/width", CStr(Me.Width / Screen.TwipsPerPixelX)
    End If
End Sub

Private Sub treTopics_Collapse(ByVal Node As MSComctlLib.Node)
    Node.Child.EnsureVisible
End Sub

Public Sub RefreshList()
    Dim objNodeList As IXMLDOMNodeList
    Dim objNodeList2 As IXMLDOMNodeList
    Dim objNode As IXMLDOMNode
    Dim objNode2 As IXMLDOMNode
    
    Dim lSectionID As Long
    Dim lTopicID As Long

    treTopics.Nodes.Clear
    
    'Booknute kluby
    With treTopics.Nodes
        Set objNodeList = frmMain.nyx.GetXMLDataList("//info/boards/category")
        For Each objNode In objNodeList
            .Add , , "section" & CStr(lSectionID), DecodeUTF8(objNode.Attributes.getNamedItem("name").text)
            Set objNodeList2 = objNode.selectNodes("board")
            lTopicID = 0
            For Each objNode2 In objNodeList2
                .Item("section" & CStr(lSectionID)).bold = True
                .Add "section" & CStr(lSectionID), tvwChild, CStr(lSectionID) & "_item_" & CStr(lTopicID) & "_id_" & CStr(objNode2.Attributes.getNamedItem("id").text), DecodeUTF8(objNode2.text) & " (Nov: " & objNode2.Attributes.getNamedItem("new").text & ")"
                .Item(CStr(lSectionID) & "_item_" & CStr(lTopicID) & "_id_" & CStr(objNode2.Attributes.getNamedItem("id").text)).EnsureVisible
                .Item(CStr(lSectionID) & "_item_" & CStr(lTopicID) & "_id_" & CStr(objNode2.Attributes.getNamedItem("id").text)).Expanded = False
                lTopicID = lTopicID + 1
            Next
            lSectionID = lSectionID + 1
        Next
    End With
    If CBool(Val(frmMain.nyx.GetSetting("windows/topics/automoveup"))) Then
        treTopics.Nodes(1).EnsureVisible
    End If
End Sub

Private Sub treTopics_DblClick()
    Call ShowTopic(GetID(treTopics.SelectedItem.key))
End Sub

Private Sub treTopics_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then
        Call ShowTopic(GetID(treTopics.SelectedItem.key))
        KeyAscii = 0
    End If
End Sub

Private Function GetID(text As String) As String
    On Error Resume Next
    Dim arrTmp() As String
    If InStr(text, "_id_") = 0 Then Exit Function
    
    arrTmp = Split(text, "_id_")
    GetID = arrTmp(1)
End Function

Private Sub ShowTopic(id As String)
    If Trim(id) = "" Or Trim(frmMain.nyx.GetSetting("webpassword")) = "" Then Exit Sub
    
    If Not RunNyxInBrowser(frmMain.nyx.UserName, frmMain.nyx.GetSetting("webpassword"), "l=topic;id=" & id) Then
        MsgBox "Nepovedlo se spustit prohle!", vbCritical + vbOKOnly
    End If
End Sub
